#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Tue Apr 28 12:01:15 2020

@author: ee18m009
"""
#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Wed Apr 22 18:41:07 2020

@author: ee18m009
"""

import numpy as np
import os
import time
import argparse
import yaml
from PIL import Image

import torch

#sys.path.insert(0, '/mnt/DATA/Chandana/IVT')
from Working_model_MDNET import MDNet, BCELoss, set_optimizer,QHead,Neg_log_density,set_requires_grad_3
from sample_generator import SampleGenerator
from data_prov import RegionExtractor
from bbreg import BBRegressor
from gen_config import gen_config

#sys.path.insert(0,'/mnt/DATA/Chandana/IVT')
from gnet.g_init import NetG, set_optimizer_g
from gnet.g_pretrain import g_pretrain
cwd=os.path.dirname(os.path.abspath(__file__))

opts = yaml.safe_load(open(os.path.join(cwd,'options_tracking.yaml'),'r'))



def forward_samples(model, image, samples, out_layer=None):
    model.eval()
    extractor = RegionExtractor(image, samples, opts)
    for i, regions in enumerate(extractor):
        if opts['use_gpu']:
            regions = regions.cuda()
        with torch.no_grad():
            feat = model(regions, out_layer=out_layer)
        if i==0:
            feats = feat.detach().clone()
        else:
            feats = torch.cat((feats, feat.detach().clone()), 0)
    return feats


def over_rat(rect1, rect2):
    '''
    Compute overlap ratio between two rects
    - rect: 1d array of [x,y,w,h] or
            2d array of N x [x,y,w,h]
    '''

    if rect1.ndim == 1:
        rect1 = rect1[None, :]
    if rect2.ndim == 1:
        rect2 = rect2[None, :]
    pos_hey=[]
    neg_hey=[]

    left = np.maximum(rect1[:, 0], rect2[:, 0])
    right = np.minimum(rect1[:, 0] + rect1[:, 2], rect2[:, 0] + rect2[:, 2])
    top = np.maximum(rect1[:, 1], rect2[:, 1])
    bottom = np.minimum(rect1[:, 1] + rect1[:, 3], rect2[:, 1] + rect2[:, 3])

    intersect = np.maximum(0, right - left) * np.maximum(0, bottom - top)
    union = rect1[:, 2] * rect1[:, 3] + rect2[:, 2] * rect2[:, 3] - intersect
    iou = np.clip(intersect / union, 0, 1)
    for i_4 in range(256):
        if iou[i_4]>0.7 and iou[i_4] <1:
          pos_hey.append(rect1[i_4])
        elif iou[i_4]<0.5 and iou[i_4]>0:
            neg_hey.append(rect1[i_4])
    return pos_hey,neg_hey


def train(model, model_g,q_net,criterion,q_loss, optimizer,optimizer_qnet, pos_feats, neg_feats, maxiter, in_layer='fc4'):
    model.train()

    batch_pos = opts['batch_pos']
    batch_neg = opts['batch_neg']
    batch_test = opts['batch_test']
    batch_neg_cand = max(opts['batch_neg_cand'], batch_neg)

    pos_idx = np.random.permutation(pos_feats.size(0))
    neg_idx = np.random.permutation(neg_feats.size(0))
    while(len(pos_idx) < batch_pos * maxiter):
        pos_idx = np.concatenate([pos_idx, np.random.permutation(pos_feats.size(0))])
    while(len(neg_idx) < batch_neg_cand * maxiter):
        neg_idx = np.concatenate([neg_idx, np.random.permutation(neg_feats.size(0))])
    pos_pointer = 0
    neg_pointer = 0
    graph_est_loss=np.zeros([maxiter])
    fgn_curve=np.zeros([maxiter])
    bgd_curve=np.zeros([maxiter])

    for i in range(maxiter):

        # select pos idx
        pos_next = pos_pointer + batch_pos
        pos_cur_idx = pos_idx[pos_pointer:pos_next]
        pos_cur_idx = pos_feats.new(pos_cur_idx).long()
        pos_pointer = pos_next

        # select neg idx
        neg_next = neg_pointer + batch_neg_cand
        neg_cur_idx = neg_idx[neg_pointer:neg_next]
        neg_cur_idx = neg_feats.new(neg_cur_idx).long()
        neg_pointer = neg_next

        # create batch
        batch_pos_feats = pos_feats[pos_cur_idx]
        if model_g is not None:
            batch_asdn_feats = pos_feats.index_select(0, pos_cur_idx)
        batch_neg_feats = neg_feats[neg_cur_idx]

        # hard negative mining
        if batch_neg_cand > batch_neg:
            model.eval()
            for start in range(0, batch_neg_cand, batch_test):
                end = min(start + batch_test, batch_neg_cand)
                batch_neg_feats=batch_neg_feats.view(batch_neg_feats.size(0),-1)
                with torch.no_grad():
                    score = model(batch_neg_feats[start:end], in_layer=in_layer,out_layer='fc6')
                if start==0:
                    neg_cand_score = score.detach()[:, 1].clone()
                else:
                    neg_cand_score = torch.cat((neg_cand_score, score.detach()[:, 1].clone()), 0)

            _, top_idx = neg_cand_score.topk(batch_neg)
            batch_neg_feats = batch_neg_feats[top_idx]
            model.train()

        if model_g is not None:
            model_g.eval()
            res_asdn = model_g(batch_asdn_feats)
            model_g.train()
            num = res_asdn.size(0)
            mask_asdn = torch.ones(num, 512, 3, 3)
            res_asdn = res_asdn.view(num, 3, 3)
            for i_1 in range(num):
                feat_ = res_asdn[i_1, :, :]
                featlist = feat_.view(1, 9).squeeze()
                feat_list = featlist.detach().cpu().numpy()
                idlist = feat_list.argsort()
                idxlist = idlist[:3]

                for k in range(len(idxlist)):
                    idx = idxlist[k]
                    row = idx // 3
                    col = idx % 3
                    mask_asdn[:, :, col, row] = 0
            mask_asdn = mask_asdn.view(mask_asdn.size(0), -1)
            if opts['use_gpu']:
                batch_asdn_feats = batch_asdn_feats.cuda()
                mask_asdn = mask_asdn.cuda()
            batch_asdn_feats = batch_asdn_feats * mask_asdn

        # forward
        if model_g is None:
            pos_score = model(batch_pos_feats, in_layer=in_layer,out_layer='fc6')
            a_1=model(batch_pos_feats,in_layer='fc4',out_layer='fc5')
        else:
            pos_score = model(batch_asdn_feats, in_layer=in_layer,out_layer='fc6')
            a_1=model(batch_asdn_feats,in_layer='fc4',out_layer='fc5')
        neg_score = model(batch_neg_feats, in_layer=in_layer,out_layer='fc6')
        
#        a_1=model(batch_pos_feats,in_layer='fc4',out_layer='fc5')
        a_2 = model(batch_neg_feats,in_layer='fc4',out_layer='fc5' )
        
        c_dim=10 
        mu_1,var_1=q_net(a_1,id_x=0)
        mu_2,var_2=q_net(a_2,id_x=1)
        
        m_1=torch.zeros((mu_1.size(0),c_dim))
        v_1=torch.zeros((var_1.size(0),c_dim))
        m_2=torch.zeros((mu_2.size(0),c_dim))
        v_2=torch.zeros((var_2.size(0),c_dim))
        
        for ii in range(mu_1.size(0)):
            for jj in range(c_dim):        
                m_1[ii,jj]=mu_1[ii]
                v_1[ii,jj]=var_1[ii]
        for ii in range(mu_2.size(0)):
            for jj in range(c_dim): 
                m_2[ii,jj]=mu_2[ii]
                v_2[ii,jj]=var_2[ii]
#                
        m_1=m_1.cuda()  
        v_1=v_1.cuda() 
        m_2=m_2.cuda()  
        v_2=v_2.cuda()
        
        c_11 = (torch.Tensor(batch_pos_feats.size(0), c_dim).uniform_(2,3))
        c_1=c_11.cuda()
        c_22 = (torch.Tensor(batch_neg_feats.size(0), c_dim).uniform_(7,8))
        c_2=c_22.cuda()
        
        loss_pos=q_loss(c_1,m_1,v_1)
        loss_neg=q_loss(c_2,m_2,v_2)
        
        estimate_loss=loss_pos.mean()+loss_neg.mean()
        graph_est_loss[i]=estimate_loss
        fgn_curve[i]=mu_1.mean()
        bgd_curve[i]=mu_2.mean()

        # optimize
        loss = criterion(pos_score, neg_score)
        model.zero_grad()
        loss.backward()
        if 'grad_clip' in opts:
            torch.nn.utils.clip_grad_norm_(model.parameters(), opts['grad_clip'])
        optimizer.step()
        
        q_net.zero_grad()
        estimate_loss.backward(retain_graph=True)
        if 'grad_clip' in opts:
            torch.nn.utils.clip_grad_norm_(q_net.parameters(), opts['grad_clip'])
        optimizer_qnet.step()

        if model_g is not None:
            start = time.time()
            prob_k = torch.zeros(9)
            for k in range(9):
                row = k // 3
                col = k % 3

                model.eval()
                batch = batch_pos_feats.view(batch_pos, 512, 3, 3)
                batch[:, :, col, row] = 0
                batch = batch.view(batch.size(0), -1)

                if opts['use_gpu']:
                    batch = batch.cuda()

                prob = model(batch, in_layer='fc4', out_layer='fc6_softmax')[:, 1]
                model.train()

                prob_k[k] = prob.sum()

            _, idx = torch.min(prob_k, 0)
            idx = idx.item()
            row = idx // 3
            col = idx % 3

            optimizer_g = set_optimizer_g(model_g)
            labels = torch.ones(batch_pos, 1, 3, 3)
            labels[:, :, col, row] = 0

            batch_pos_feats = batch_pos_feats.view(batch_pos_feats.size(0), -1)
            res = model_g(batch_pos_feats)
            labels = labels.view(batch_pos, -1)
            criterion_g = torch.nn.MSELoss(reduction='mean')
            loss_g_2 = criterion_g(res.float(), labels.cuda().float())
            model_g.zero_grad()
            loss_g_2.backward()
            optimizer_g.step()

            end = time.time()
 #           print("retrainig . . .")
#            print('asdn objective %.3f, %.2f s' % (loss_g_2, end - start))
    return graph_est_loss,fgn_curve,bgd_curve

class run_vital(object):
    def __init__(self,image, init_bbox, gt=None):
   # Init bbox
        cwd=os.path.dirname(os.path.abspath(__file__))
        self.target_bbox = np.array(init_bbox)
        self.count = 1
         # Init model
        model = MDNet(os.path.join(cwd,opts['model_path']))
        model_g = NetG(os.path.join(cwd,opts['model_g_path']))
        q_net=QHead(os.path.join(cwd,opts['q_net_path']))
        if opts['use_gpu']:
            self.model = model.cuda()
            self.model_g = model_g.cuda()
            self.q_net=q_net.cuda()
        
        # Init criterion and optimizer 
        self.criterion = BCELoss()
        criterion_g = torch.nn.MSELoss(reduction='mean')
        self.q_loss=Neg_log_density()
        self.model.set_learnable_params(opts['ft_layers'])
        self.model_g.set_learnable_params(opts['ft_layers'])
        init_optimizer = set_optimizer(self.model, opts['lr_init'], opts['lr_mult'])
        self.update_optimizer = set_optimizer(self.model, opts['lr_update'], opts['lr_mult'])
        self.optimizer_qnet=set_requires_grad_3(q_net,True)
        
#        tic = time.time()
        # Load first image
        
        # Draw pos/neg samples
        pos_examples = SampleGenerator('gaussian', image.size, opts['trans_pos'], opts['scale_pos'])(
                            self.target_bbox, opts['n_pos_init'], opts['overlap_pos_init'])
        
        neg_examples = np.concatenate([
                        SampleGenerator('uniform', image.size, opts['trans_neg_init'], opts['scale_neg_init'])(
                            self.target_bbox, int(opts['n_neg_init'] * 0.5), opts['overlap_neg_init']),
                        SampleGenerator('whole', image.size)(
                            self.target_bbox, int(opts['n_neg_init'] * 0.5), opts['overlap_neg_init'])])
        neg_examples = np.random.permutation(neg_examples)
        
        # Extract pos/neg features
        pos_feats = forward_samples(self.model, image, pos_examples,out_layer='conv3')
        neg_feats = forward_samples(self.model, image, neg_examples,out_layer='conv3')
        
        # Initial training
        loss_estimation, mmm_1,nnn_1=train(self.model, None,q_net, self.criterion,self.q_loss, init_optimizer,self.optimizer_qnet, pos_feats, neg_feats, opts['maxiter_init'])
        del init_optimizer, neg_feats
#        torch.cuda.empty_cache()
        g_pretrain(self.model, self.model_g, criterion_g, pos_feats)
#        torch.cuda.empty_cache()
        
        # Train bbox regressor
        bbreg_examples = SampleGenerator('uniform', image.size, opts['trans_bbreg'], opts['scale_bbreg'], opts['aspect_bbreg'])(
                            self.target_bbox, opts['n_bbreg'], opts['overlap_bbreg'])
        self.bbreg_feats = forward_samples(self.model, image, bbreg_examples,out_layer='conv3')
        self.bbreg = BBRegressor(image.size)
        self.bbreg.train(self.bbreg_feats, bbreg_examples, self.target_bbox)
#        del self.bbreg_feats
#        torch.cuda.empty_cache()
        
        # Init sample generators for update
        self.sample_generator = SampleGenerator('gaussian', image.size, opts['trans'], opts['scale'])
        self.pos_generator = SampleGenerator('gaussian', image.size, opts['trans_pos'], opts['scale_pos'])
        self.neg_generator = SampleGenerator('uniform', image.size, opts['trans_neg'], opts['scale_neg'])
        
        # Init pos/neg features for update
        neg_examples = self.neg_generator(self.target_bbox, opts['n_neg_update'], opts['overlap_neg_init'])
        neg_feats = forward_samples(self.model, image, neg_examples,out_layer='conv3')
        self.pos_feats_all = [pos_feats]
        self.neg_feats_all = [neg_feats]
    # Main loop
#    for i in range(1, sequence_len):
    #    if i<303:
    def tracking_method(self,image):    
#        tic = time.time()
        # Load image
#        image = Image.open(img_list[i]).convert('RGB')

        # Estimate target bbox
        samples = self.sample_generator(self.target_bbox, opts['n_samples'])
        
        
        sample_scores = forward_samples(self.model, image, samples, out_layer='fc6')
    
        pos_test,pos_index = sample_scores[:, 1].topk(20)
        
        sorted_length, sorted_index = torch.sort(sample_scores[:,0], dim=0, descending=True)
        
        
    
        
        pos_index= pos_index.cpu()
        neg_index= sorted_index[0:49].cpu()
        total_pos=samples[pos_index]
        total_neg=samples[neg_index]
        pos_tic=forward_samples(self.model,image,total_pos,out_layer='fc5')
        neg_tic=forward_samples(self.model,image,total_neg,out_layer='fc5')
        
        
    #    a_1=self.model(pos_tic, in_layer='fc',out_layer='fc5')
    #    a_2 = self.model(neg_tic,in_layer='fc4',out_layer='fc5' )
        
        
        mu_1,var_1=self.q_net(pos_tic,id_x=0)
        mu_2,var_2=self.q_net(neg_tic,id_x=1)
        
        
        
        
        
        
        pos_diff=torch.abs(2.5-mu_1)
        m_sample, m_index = torch.sort(pos_diff,dim=0, descending=False)
    #    top_scores ,top_idx = m_sample.topk(5)
        
    
    #    top_scores, top_idx = sample_scores[:, 1].topk(5)
        
        ind_ex=torch.zeros(5,dtype=torch.int32)
        top_scores=torch.zeros(5)
        
        for h_1 in range(5):
            ind_ex[h_1]=pos_index[m_index[h_1]]
            top_scores[h_1]=sample_scores[pos_index[m_index[h_1]],1]
        
        
        top_idx = ind_ex.cpu()
        target_score = top_scores.mean()
        target_bbox = samples[top_idx]
        if top_idx.shape[0] > 1:
            target_bbox = target_bbox.mean(axis=0)
        success = target_score > 0
        
        # Expand search area at failure
        if success:
            self.sample_generator.set_trans(opts['trans'])
        else:
            self.sample_generator.expand_trans(opts['trans_limit'])

        # Bbox regression
        if success:
            bbreg_samples = samples[top_idx]
            if top_idx.shape[0] == 1:
                bbreg_samples = bbreg_samples[None,:]
            bbreg_feats = forward_samples(self.model, image, bbreg_samples,out_layer='conv3')
            self.bbreg_samples = self.bbreg.predict(bbreg_feats, bbreg_samples)
            bbreg_bbox = bbreg_samples.mean(axis=0)
        else:
            bbreg_bbox = target_bbox

        # Save result
#        result[i] = target_bbox
# self.       result_bb[i] = bbreg_bbox

        # Data collect
        if success:
            pos_examples = self.pos_generator(target_bbox, opts['n_pos_update'], opts['overlap_pos_update'])
            pos_feats = forward_samples(self.model, image, pos_examples,out_layer='conv3')
            self.pos_feats_all.append(pos_feats)
            if len(self.pos_feats_all) > opts['n_frames_long']:
                del self.pos_feats_all[0]

            neg_examples = self.neg_generator(target_bbox, opts['n_neg_update'], opts['overlap_neg_update'])
            neg_feats = forward_samples(self.model, image, neg_examples,out_layer='conv3')
            self.neg_feats_all.append(neg_feats)
            if len(self.neg_feats_all) > opts['n_frames_short']:
                del self.neg_feats_all[0]

        # Short term update
        if not success:
            nframes = min(opts['n_frames_short'], len(self.pos_feats_all))
            pos_data = torch.cat(self.pos_feats_all[-nframes:], 0)
            neg_data = torch.cat(self.neg_feats_all, 0)
            loss_estimation, mmm_1,nnn_1=train(self.model, None,self.q_net, self.criterion,self.q_loss, self.update_optimizer,self.optimizer_qnet, pos_data, neg_data, opts['maxiter_update'])

        # Long term update
        elif self.count % opts['long_interval'] == 0:
             pos_data = torch.cat(self.pos_feats_all, 0)
             neg_data = torch.cat(self.neg_feats_all, 0)
             loss_estimation, mmm_1,nnn_1=train(self.model, self.model_g,self.q_net, self.criterion,self.q_loss, self.update_optimizer,self.optimizer_qnet, pos_data, neg_data, opts['maxiter_update']) 
     #   print('Frame {:d}, Score {:.3f}'.format(self.count + 1, target_score))
        self.target_bbox = bbreg_bbox
        self.count =self.count+1
        return bbreg_bbox, target_score


if __name__ == "__main__":

    parser = argparse.ArgumentParser()
    parser.add_argument('-s', '--seq', default='bag', help='input seq')
    parser.add_argument('-j', '--json', default='', help='input json')
    parser.add_argument('-f', '--savefig', action='store_true')
    parser.add_argument('-d', '--display', action='store_true')

    args = parser.parse_args()
    assert args.seq != '' or args.json != ''

    np.random.seed(0)
    torch.manual_seed(0)

    # Generate sequence config
    img_list, init_bbox, gt, savefig_dir, display, result_path = gen_config(args)

    # Run tracker
    sequence_len = len(img_list)
    image = Image.open(img_list[0]).convert('RGB')

    abc = run_vital(image, init_bbox)
    
    for i in range(1, sequence_len-1):
        image = Image.open(img_list[i]).convert('RGB')
 
        bb,conf=abc.tracking_method(image)

